
#define LIARC_IN_MICROCODE
#include "liarc.h"

#undef DECLARE_COMPILED_CODE
#undef DECLARE_COMPILED_DATA
#undef DECLARE_COMPILED_DATA_NS
#undef DECLARE_DATA_OBJECT

#define DECLARE_COMPILED_CODE(name, nentries, decl_code, code)		\
extern liarc_decl_code_t decl_code;					\
extern liarc_code_proc_t code;

#define DECLARE_COMPILED_DATA(name, decl_data, data)			\
extern liarc_decl_data_t decl_data;					\
extern liarc_data_proc_t data;

#define DECLARE_COMPILED_DATA_NS(name, data)				\
extern liarc_data_proc_t data;

#define DECLARE_DATA_OBJECT(name, data)					\
extern liarc_object_proc_t data;

#include "compinit.h"

#undef DECLARE_COMPILED_CODE
#undef DECLARE_COMPILED_DATA
#undef DECLARE_COMPILED_DATA_NS
#undef DECLARE_DATA_OBJECT

#define DECLARE_COMPILED_CODE(name, nentries, decl_code, code)		\
  result = (declare_compiled_code (name, nentries, decl_code, code));	\
  if (result != 0)							\
    return (result);

#define DECLARE_COMPILED_DATA(name, decl_data, data)			\
  result = (declare_compiled_data (name, decl_data, data));		\
  if (result != 0)							\
    return (result);

#define DECLARE_COMPILED_DATA_NS(name, data)				\
  result = (declare_compiled_data_ns (name, data));			\
  if (result != 0)							\
    return (result);

#define DECLARE_DATA_OBJECT(name, data)					\
  result = (declare_data_object (name, data));				\
  if (result != 0)							\
    return (result);

int
initialize_compiled_code_blocks (void)
{
  int result;
#include "compinit.h"
  return (0);
}
